<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:a4j="http://richfaces.org/a4j"
                xmlns="http://www.w3.org/1999/xhtml">
    <s:div id="globalDiv">
        <ui:insert name="infoOnValidatedObject"/>
        <h:form id="testDetailsForm">
            <gri:panel id="utDetails">
                <f:facet name="header">
                    <h:outputText value="#{messages['gazelle.vut.UnitTestDetails']}"/>
                </f:facet>
                <s:decorate template="/layout/edit.xhtml">
                    <ui:define name="label">#{messages['gazelle.vut.Keyword']}</ui:define>
                    <h:inputText value="#{managedBean.unitTest.keyword}" required="true"
                                 requiredMessage="The keyword is a mandatory attribute" size="100"/>
                </s:decorate>
                <s:decorate template="/layout/edit.xhtml">
                    <ui:define name="label">#{messages['gazelle.vut.Active']}</ui:define>
                    <h:selectBooleanCheckbox value="#{managedBean.unitTest.active}"/>
                </s:decorate>
                <s:decorate template="/layout/edit.xhtml">
                    <ui:define name="label">#{messages['gazelle.vut.ExpectedResult']}</ui:define>
                    <h:selectOneMenu value="#{managedBean.unitTest.expectedResult}">
                        <f:selectItems value="#{managedBean.availableResults}"/>
                    </h:selectOneMenu>
                </s:decorate>
                <s:decorate template="/layout/edit.xhtml">
                    <ui:define name="label">#{messages['gazelle.vut.Comment']}</ui:define>
                    <h:inputTextarea value="#{managedBean.unitTest.comment}" rows="3" cols="80"
                                     style="resize:both;" styleClass="form-control"/>
                </s:decorate>
                <ui:insert name="extraUnitTestAttributes"/>
                <s:div rendered="#{managedBean.unitTest.executed()}">
                    <dl class="dl-horizontal">
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.vut.LastResult']}</ui:define>
                        <h:outputText value="#{utManagerBean.getLastResultLabel(managedBean.unitTest)}"
                                      styleClass="#{utManagerBean.getLastResultStyle(managedBean.unitTest)}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.vut.LastRunDate']}</ui:define>
                        <g:date value="#{managedBean.unitTest.lastRunDate}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{managedBean.unitTest.lastSuccessDate != nll}">
                        <ui:define name="label">#{messages['gazelle.vut.LastSucessDate']}</ui:define>
                        <g:date value="#{managedBean.unitTest.lastSuccessDate}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml"
                                rendered="#{not empty managedBean.unitTest.reasonForFailure}">
                        <ui:define name="label">#{messages['gazelle.vut.ReasonForFailure']}</ui:define>
                        <h:outputText value="#{managedBean.unitTest.reasonForFailure}"/>
                    </s:decorate>
                    </dl>
                </s:div>
                    <a4j:commandButton value="#{messages['gazelle.vut.Save']}" actionListener="#{managedBean.save()}" styleClass="gzl-btn-green"
                                       render="globalDiv"/>
                    <a4j:commandButton value="#{messages['gazelle.vut.RunTest']}" styleClass="gzl-btn-blue"
                                       action="#{utManagerBean.executeTestAndRefreshPage(managedBean.unitTest)}"
                                       render="utDetails"/>
                    <a4j:commandButton value="#{messages['gazelle.vut.ShowLogs']}" styleClass="gzl-btn-blue"
                                       action="#{utManagerBean.displayUnitTestLogs(managedBean.unitTest)}"/>
            </ui:decorate>
            <br/>

            <gri:panel id="unitTestInputPanel">
                <f:facet name="header">
                    <h:outputText value="#{messages['gazelle.vut.UnitTestInputs']}"/>
                </f:facet>

                <gri:panel rendered="#{managedBean.unitTestFile != null}" id="unitTestFileDef">
                    <dl class="dl-horizontal">
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.vut.InputKeyword']}</ui:define>
                        <h:outputText value="#{managedBean.unitTestFile.inputKeyword}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.vut.InputType']}</ui:define>
                        <h:outputText value="#{managedBean.unitTestFile.inputType.value}"/>
                    </s:decorate>
                    </dl>
                    <s:decorate template="/layout/edit.xhtml">
                        <ui:define name="label">#{messages['gazelle.vut.Comment']}</ui:define>
                        <h:inputTextarea value="#{managedBean.unitTestFile.comment}" rows="3" cols="80"
                                         style="resize:both;" styleClass="form-control"/>
                    </s:decorate>

                    <s:div>
                        <h:outputText value="#{messages['gazelle.vut.SampleFile']}" style="font-weight:bold;"/>
                        <rich:fileUpload fileUploadListener="#{managedBean.fileUploadListener}" id="upload"
                                         maxFilesQuantity="1" listWidth="230px" immediateUpload="true"
                                         enctype="multipart/form-data"/>
                    </s:div>
                    <a4j:commandButton value="#{messages['gazelle.vut.Save']}" styleClass="gzl-btn-green"
                                       actionListener="#{managedBean.addUnitTestFile()}"
                                       render="unitTestInputPanel"/>
                </gri:panel>
                <ui:insert name="newInputCreation"/>
                <ui:insert name="buttonToCreateNewFile"/>
                <br/>
                <br/>
                <rich:dataTable styleClass="table table-hover" value="#{managedBean.unitTest.files}" var="file"
                                id="filesTable">
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.vut.InputKeyword']}</ui:define>
                        <h:outputText value="#{file.inputKeyword}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.vut.InputType']}</ui:define>
                        <h:outputText value="#{file.inputType.value}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.vut.Filename']}</ui:define>
                        <h:outputText value="#{file.filepath}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.vut.Comment']}</ui:define>
                        <h:outputText value="#{file.comment}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.vut.Actions']}</ui:define>
                        <h:graphicImage value="/img/icons64/deleteRedJR.gif" styleClass="tableIcon"
                                        id="deleteFileImg"
                                        title="#{messages['gazelle.vut.DeleteFile']}">
                            <a4j:ajax event="click" for="deleteFileImg" render="filesTable"
                                      listener="#{managedBean.deleteUnitTestFile(file)}"/>
                        </h:graphicImage>
                    </g:column>
                </rich:dataTable>
            </gri:panel>
        </h:form>
    </s:div>
</ui:composition>
